<?php
/*
 * This work is hereby released into the Public Domain.
 * To view a copy of the public domain dedication,
 * visit http://creativecommons.org/licenses/publicdomain/ or send a letter to
 * Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
 *
 */

// Petite modification : <protected $colors> remplacé par <public $colors> pour avoir les couleurs ici
require_once "libartichow/Pie.class.php";

function html2rgb($color) {
	return array(
		hexdec(substr($color, 0, 2)),
		hexdec(substr($color, 2, 2)),
		hexdec(substr($color, 4, 2))
	);
}

function createPie($labels, $values, $zeros, $categories) {
	$couleurs = $categories ?
		explode(' ', '810100 ff0100 ff6300 ffcf00') :
		explode(' ', '7b2fb1 c97c21 2d3ab5 ae1f0c e1d738 51e7de 17701b 223b35 685b10 13f00d 50c5cf');

	$plot = new Pie($values, Pie::DARK);
	$plot->colors = NULL;

	if($categories) {
		foreach($labels AS $label) {
			$label = str_replace('Niveau ', '', $label);
			$rgb = html2rgb($couleurs[$label-1]);
			$plot->colors[] = new awColor($rgb[0], $rgb[1], $rgb[2]);
		}
	} else {
		foreach($couleurs AS $couleur) {
			$rgb = html2rgb($couleur);
			$plot->colors[] = new awColor($rgb[0], $rgb[1], $rgb[2]);
		}
	}

	$plot->label->setFont(new Tuffy(15));
	$plot->setLabelPrecision(2);
	$plot->setLabelMinimum(2);
	$plot->legend->setPosition(1.05, -0.1);
	$plot->legend->setTextFont(new Tuffy(15));
	$plot->setLabelPosition(5);
	$plot->setSize(0.8, 0.6);
	$plot->set3D(15);
	$plot->setBorderColor(new White);
	$plot->setLegend($labels);

	foreach($zeros AS $label) {
		$plot->legend->add(new awPiePart(new awColor(160, 160, 160)), $label, awLegend::BACKGROUND);
	}

	return $plot;
}

$graph = new Graph(500, 500);
$graph->setAntiAliasing(TRUE);

$labels = explode('*', $_GET['label']);
$valeurs = explode('*', $_GET['data']);

$zeros = Array();
for($i = 0; $i < count($valeurs); $i++) {
	if($valeurs[$i] < 0.01) {
		$zeros[] = $labels[$i];

		unset($labels[$i]);
		unset($valeurs[$i]);
	}
}

$plot = createPie(
	$labels,
	$valeurs,
	$zeros,
	isset($_GET['categories'])
);

$graph->border->hide();
$graph->add($plot);
$graph->draw();
?> 
