#!/usr/bin/perl -w

# Copyright (C) 2010 Julien VAUBOURG
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use lib '/home/sonde/classes';
use PSM::RRD;
use PSM::LaTeX;

# Creation du CGI
$cgi = new CGI;
$cgi->charset('utf-8');
print $cgi->header();

# Variables
my $template;
my $page;

# Recuperation du template
open(TEMPLATE, '../tpl/main.tpl') or die "ERREUR: Impossible d'ouvrir main.tpl\n";
$template .= $_ while <TEMPLATE>;
close TEMPLATE;


####
#### ENREGISTREMENT DES DONNEES
####

# Ecriture du nouveau fichier infos si des donnees ont ete envoyees
if($ENV{CONTENT_LENGTH} != 0) {
	my $infos = $cgi->param('debut')."\n";
	$infos .= $cgi->param('fin')."\n";
	$infos .= $cgi->param('client')."\n";
	$infos .= $cgi->param('intro');

	# Ecriture du nouveau fichier infos
	open(INFOS, ">$RRD::root/config/infos") or die "Impossible d'ouvrir $RRD::root/config/infos\n";
	print INFOS $infos;
	close(INFOS);

	LaTeX::lireInfos();
}


####
#### AFFICHAGE DE LA PAGE
####

# Debut du formulaire
$page .= "<form action='divers.cgi' method='post' id='divers'>"
	."<h2>Informations diverses</h2>"
	."<ul id='leDivers'>"

	."<li>Nom de l'établissement du client :<br /><input type='text' name='client' value=\"$LaTeX::client\" /><br /><br /></li>"
	."<li>Date de début de la capture :<input type='text' name='debut' value='".RRD::jour($RRD::debut)."' /></li>"
	."<li>Date de fin de la capture : <input type='text' name='fin' value='".RRD::jour($RRD::fin)."' /><br /><br /></li>"
	."<li>Introduction au rapport :<br /><textarea name='intro'>$LaTeX::intro</textarea></li>"

	."</ul>"

	# Enregistrement des modifications
	."<div class='boutons'>"
	."	<input type='submit' value='Enregistrer' class='boutonEnregistrer' />"
	."</div>"
	."</form>";

$template =~ s/<TITLE>/Informations diverses/;
$template =~ s/<ONLOAD>//;
$template =~ s/<PAGE>/$page/;
print $template;
