#!/usr/bin/perl -w

# Copyright (C) 2010 Julien VAUBOURG
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use lib '/home/sonde/classes';
use PSM::Zones;

# Creation du CGI
$cgi = new CGI;
$cgi->charset('utf-8');
print $cgi->header();

# Variables
my $template;
my $lignesFlux;
my @flux;
my $nbFlux = 0;
my $page;

# Recuperation du template
open(TEMPLATE, '../tpl/main.tpl') or die "ERREUR: Impossible d'ouvrir main.tpl\n";
$template .= $_ while <TEMPLATE>;
close TEMPLATE;


####
#### ENREGISTREMENT DES DONNEES
####

# Ecriture du nouveau fichier flux.tab si des donnees ont ete envoyees
if($ENV{CONTENT_LENGTH} != 0) {
	my @lesFlux;

	# Pour chaque select envoye en POST
	foreach my $param ($cgi->param()) {

		# Creation d'une liste de tous les flux declares rencontres
		if($param =~ m/^(flux[0-9]+)_[AB]{1}$/ && !grep($_ eq $1, @lesFlux)) {
			push(@lesFlux, $1);
		}
	}

	my $fluxTab = "\@flux = (\n";

	# Pour chacun des flux a declarer
	foreach (@lesFlux) {

		# Creation d'une entree dans la liste de flux.tab, avec un tableau contenant les deux membres du flux
		$fluxTab .= '["'.$cgi->param("${_}_A").'","'.$cgi->param("${_}_B").'"],'."\n";
	}

	$fluxTab .= ');';

	# Ecriture du nouveau gzones.hash
	open(FLUX, ">$RRD::root/config/flux.tab") or die "Impossible d'ouvrir $RRD::root/config/flux.tab\n";
	print FLUX $fluxTab;
	close(FLUX);
}


####
#### AFFICHAGE DE LA PAGE
####

# Recuperation de la liste des flux a observer (initialisation de @flux)
open(FLUX, "$RRD::root/config/flux.tab") or die "ERREUR: Impossible d'ouvrir $RRD::root/config/flux.tab\n";
$lignesFlux .= $_ while <FLUX>;
eval $lignesFlux;
close FLUX;

my $zonesGZones;

# Generation de la liste des zones et GZones pour les selects
foreach my $idZone (sort { Zones::label($a) cmp Zones::label($b) } keys(%Zones::zones)) {
	my $zone = %Zones::zones->{$idZone};
	$zonesGZones .= "<option value='$idZone'>@{$zone}[0]</option>";
}

$zonesGZones .= "<option class='separation' disabled='disabled'>Groupes de zones</option>";

foreach my $idGZone (sort { Zones::label($a) cmp Zones::label($b) } keys(%Zones::GZones)) {
	my $GZone = %Zones::GZones->{$idGZone};
	$zonesGZones .= "<option value='GZONE:$idGZone'>@{$GZone}[0]</option>";
}

$zonesGZones .= "<option value='internet'>Internet</option>";

# Debut du formulaire
$page .= "<form action='flux.cgi' method='post' id='flux'>"
	."<h2>Définitions des flux à observer</h2>"
	."<ul id='lesFlux'>";

# Pour chaque flux
foreach (@flux) {

	# Premier select : selection de la premiere zone ou GZone du flux
	my $zonesGZonesA = $zonesGZones;
	$zonesGZonesA =~ s/(value='@$_[0]')/\1 selected='selected'/;
	$zonesGZonesA = "<option value='@$_[0]' class='attention'>???</option>".$zonesGZonesA if $zonesGZonesA !~ /selected=/;

	# Second select : selection de la seconde zone ou GZone du flux
	my $zonesGZonesB = $zonesGZones;
	$zonesGZonesB =~ s/(value='@$_[1]')/\1 selected='selected'/;
	$zonesGZonesB = "<option value='@$_[1]' class='attention'>???</option>".$zonesGZonesB if $zonesGZonesB !~ /selected=/;

	# Ligne d'un flux modifiable ou supprimable
	$page  .= "<li>"
		."Entre <select name='flux".($nbFlux)."_A'>"
		.$zonesGZonesA
		."</select> et "
		."<select name='flux".($nbFlux++)."_B'>"
		.$zonesGZonesB
		."</select>"
		."<input type='button' value='X' title='Supprimer ce flux' onclick='Zones.supprimer.apply(this)' class='boutonSup' />"
		."</li>";
}

# Possibilite d'ajouter un flux
$page  .= "<li>"
	."Entre <select class='champAjout'>"
	."<option>-</option>"
	.$zonesGZones
	."</select> et "
	."<select class='champAjout'>"
	."<option>-</option>"
	.$zonesGZones
	."</select> "
	."<input type='button' value='Ajouter' onclick='Flux.ajouterFlux.apply(this)' class='boutonAjout' />"
	."</li>"
	."</ul>"

	# Liste des zones et GZones pour la creation dynamique de select
	."<select id='listeDesZones'>"
	.$zonesGZones
	. "</select>"

	# Dernier identifiant de flux cree
	."<input type='hidden' id='dernierId' value='$nbFlux' />"

	# Enregistrement des modifications
	."<div class='boutons'>"
	."	<input type='submit' value='Enregistrer' class='boutonEnregistrer' />"
	."</div>"
	."</form>"

	# Bandeau patientez
	."<div id='patientez'>Patientez</div>";

$template =~ s/<TITLE>/Gestion des Flux/;
$template =~ s/<ONLOAD>//;
$template =~ s/<PAGE>/$page/;
print $template;
