#!/usr/bin/perl -w

# Copyright (C) 2010 Julien VAUBOURG
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use lib '/home/sonde/classes';
use PSM::Zones;

# Creation du CGI
$cgi = new CGI;
$cgi->charset('utf-8');
print $cgi->header();

# Variables
my $template;
my $nbMatrice = 0;
my $page;

# Recuperation du template
open(TEMPLATE, '../tpl/main.tpl') or die "ERREUR: Impossible d'ouvrir main.tpl\n";
$template .= $_ while <TEMPLATE>;
close TEMPLATE;


####
#### ENREGISTREMENT DES DONNEES
####

# Ecriture du nouveau fichier matrice.tab si des donnees ont ete envoyees
if($ENV{CONTENT_LENGTH} != 0) {
	my @lesZonesGZones;
	my $matriceTab = "\@Zones::matrice = (\n";

	# Pour chaque select envoye en POST
	foreach ($cgi->param()) {
		if($_ =~ m/^matrice[0-9]+$/) {

			# Creation d'une entree dans la liste de matrice.tab
			$matriceTab .= '"'.$cgi->param($_).'",'."\n";
		}
	}

	$matriceTab .= ');';

	# Ecriture du nouveau gzones.hash
	open(MATRICE, ">$RRD::root/config/matrice.tab") or die "Impossible d'ouvrir $RRD::root/config/matrice.tab\n";
	print MATRICE $matriceTab;
	close(MATRICE);

	Zones::lire();
}


####
#### AFFICHAGE DE LA PAGE
####

my $zonesGZones;

# Generation de la liste des zones et GZones pour les selects
foreach my $idZone (sort { Zones::label($a) cmp Zones::label($b) } keys(%Zones::zones)) {
	my $zone = %Zones::zones->{$idZone};
	$zonesGZones .= "<option value='$idZone'>@{$zone}[0]</option>";
}

$zonesGZones .= "<option class='separation' disabled='disabled'>Groupes de zones</option>";

foreach my $idGZone (sort { Zones::label($a) cmp Zones::label($b) } keys(%Zones::GZones)) {
	my $GZone = %Zones::GZones->{$idGZone};
	$zonesGZones .= "<option value='GZONE:$idGZone'>@{$GZone}[0]</option>";
}

$zonesGZones .= "<option value='internet'>Internet</option>";

# Debut du formulaire
$page .= "<form action='matrice.cgi' method='post' id='matrice'>"
	."<h2>Définition de la matrice</h2>"
	."<ul id='laMatrice'>";

# Pour chaque zone/GZone qui compose la matrice
foreach (@Zones::matrice) {

	# Select d'une zone/GZone
	my $zonesGZonesLigne = $zonesGZones;
	$zonesGZonesLigne =~ s/(value='$_')/\1 selected='selected'/;
	$zonesGZonesLigne = "<option value='$_' class='attention'>???</option>".$zonesGZonesLigne if $zonesGZonesLigne !~ /selected=/;

	# Ligne d'un zone/GZone modifiable
	$page  .= "<li>"
		."<select name='matrice".($nbMatrice++)."'>"
		.$zonesGZonesLigne
		."</select>"
		."<input type='button' value='X' title='Supprimer cette zone/GZone' onclick='Zones.supprimer.apply(this)' class='boutonSup' />"
		."</li>";
}

# Possibilite d'ajouter une zone/GZone
$page  .= "<li>"
	."<select class='champAjout'>"
	."<option>-</option>"
	.$zonesGZones
	."</select>"
	."<input type='button' value='Ajouter' onclick='Matrice.ajouterZoneGZone.apply(this)' class='boutonAjout' />"
	."</li>"
	."</ul>"

	# Liste des zones et GZones pour la creation dynamique de select
	."<select id='listeDesZones'>"
	.$zonesGZones
	. "</select>"

	# Dernier identifiant de matrice cree
	."<input type='hidden' id='dernierId' value='$nbMatrice' />"

	# Enregistrement des modifications
	."<div class='boutons'>"
	."	<input type='submit' value='Enregistrer' class='boutonEnregistrer' />"
	."</div>"
	."</form>"

	# Bandeau patientez
	."<div id='patientez'>Patientez</div>";

$template =~ s/<TITLE>/Gestion de la matrice/;
$template =~ s/<ONLOAD>//;
$template =~ s/<PAGE>/$page/;
print $template;
