#!/usr/bin/perl -w

# Copyright (C) 2010 Julien VAUBOURG
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use lib '/home/sonde/classes';
use PSM::Zones;

# Creation du CGI
$cgi = new CGI;
$cgi->charset('utf-8');
print $cgi->header();

# Variables
my $template;
my $dernierId;
my $page;

# Recuperation du template
open(TEMPLATE, '../tpl/main.tpl') or die "ERREUR: Impossible d'ouvrir main.tpl\n";
$template .= $_ while <TEMPLATE>;
close TEMPLATE;


####
#### ENREGISTREMENT DES DONNEES
####

# Ecriture du nouveau fichier zones.hash si des donnees ont ete envoyees
if($ENV{CONTENT_LENGTH} != 0) {
	my %adressesZones;

	# Pour chaque champ envoye en POST, par ordre numerique des noms de zones
	foreach (sort { int substr($a, 4) <=> int substr($b, 4) } $cgi->param()) {

		# Si c'est une adresse qui compose une zone (et non un nom de zone), on ajoute a la liste d'adresses de cette zone
		if($_ =~ m/^zone([0-9]+)_adresse$/) {
			push(@{%adressesZones->{$1}}, $cgi->param($_));
		}
	}

	my $zonesHash = "\%Zones::zones = (\n";

	# Pour chacune des listes d'adresses de zones
	foreach (sort keys %adressesZones) {

		# Creation d'une entree dans le hash de zones, en specifiant le nom de la zone
		$zonesHash .= '"'.$_.'" => ["'.$cgi->param("zone$_").'", ["'.join('","', @{%adressesZones->{$_}}).'"]],'."\n";
	}

	$zonesHash .= ');';

	# Ecriture du nouveau zones.hash
	open(ZONES, ">$RRD::root/config/zones.hash") or die "Impossible d'ouvrir $RRD::root/config/zones.hash\n";
	print ZONES $zonesHash;
	close(ZONES);

	# Interpretation des nouvelles zones pour la page en cours
	Zones::lire();
}


####
#### AFFICHAGE DE LA PAGE
####

$page .= "<form action='zones.cgi' method='post' id='zones'>"
	."<h2>Définitions des zones</h2>";

$page .= "<ul id='lesZones'>";

# Pour chaque zone existante
foreach my $id (sort { $a <=> $b } keys %Zones::zones) {

	# Uniquement les zones qui ne sont pas creees automatiquement
	if($id =~ /^[0-9]+$/) {
		my @zone = @{%Zones::zones->{$id}};
		my @adresses = @{@zone[1]};
		my $zone = @zone[0];

		# Affichage de la zone modifiable et supprimable
		$page  .= "<li>"
			."	<input type='text' name='zone$id' value=\"$zone\" class='champNomZone' /><input type='button' value='X' title='Supprimer cette zone' onclick='Zones.supprimer.apply(this)' class='boutonSup' />"
			."	<ul id='zone$id'>";
		$page  .= "		<li><input type='text' name='zone${id}_adresse' value='$_' onchange='Zones.convertirMasque.apply(this)' /><input type='button' value='X' title='Supprimer' onclick='Zones.supprimer.apply(this)' class='boutonSup' /></li>" foreach (@adresses);
		$page  .= "		<li><input type='text' class='champAjout ajoutAttente' onfocus='Zones.libelleAjout(\"adresse\", 1, this)' onblur='Zones.convertirMasque.apply(this); Zones.libelleAjout(\"adresse\", 0, this)' value='Nouvelle adresse' /><input type='button' value='Ajouter' onclick='Zones.ajouterAdresse.apply(this)' class='boutonAjout' /></li>"
			."	</ul>"
			."</li>";

		$dernierId = $id;
	}
}

# Ajout d'une zone
$page .= "	<li><input type='text' class='champAjout ajoutAttente' onfocus='Zones.libelleAjout(\"zone\", 1, this)' onblur='Zones.libelleAjout(\"zone\", 0, this)' value='Nouvelle zone' /><input type='button' value='Ajouter' onclick='Zones.ajouterZone.apply(this)' class='boutonAjout' /></li>"
	."</ul>"

	# Dernier identifiant de zone cree
	."<input type='hidden' id='dernierId' value='$dernierId' />"

	# Enregistrement
	."<div class='boutons'>"
	."	<input type='submit' value='Enregistrer' class='boutonEnregistrer' />"
	."</div>"
	."</form>";

# Liste des zones pour les selects crees dynamiquement
$page .= "<div id='listeipFix'>"
	."<div id='listeip'>";
$page .= "	<span class='ip".($i++%2)."'>$_</span>" foreach (sort @{Zones::listerIP('local')});
$page .= "</div>"
	."<input type='button' onclick='Zones.patientez(\"Zones.majListeIP()\")' value='Mise à jour' />"
	."</div>";

# Bandeau patientez
$page .= "<div id='patientez'>Patientez</div>";

# Affichage concret de la page
$template =~ s/<TITLE>/Gestion des zones/;
$template =~ s/<ONLOAD>/Zones.patientez('Zones.majListeIP()')/;
$template =~ s/<PAGE>/$page/;
print $template;
