/*
 * Copyright (C) 2010 Julien VAUBOURG
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

Flux = {

	// Ajoute une flux compose de deux selects dans la liste des flux modifiables, par l'intermediaire de la derniere ligne
	// des flux
	// REM: Dans le contexte d'un bouton d'ajout de flux
	ajouterFlux: function() {

		// Recuperation des deux select qui permettent d'ajouter ce nouveau flux
		var selectZoneB = Noeuds.noeudPrecedent.apply(this);
		var selectZoneA = Noeuds.noeudPrecedent.apply(selectZoneB);

		// Si ces deux flux ont bien ete initalises sur des zones ou GZones
		if(selectZoneA[selectZoneA.selectedIndex].text != '-' && selectZoneB[selectZoneB.selectedIndex].text != '-') {
			var liste = this.parentNode.parentNode;

			// Creation des elements a ajouter
			var nouvelleLigne = document.createElement('li');
			var nouveauSelecteurA = document.createElement('select');
			var nouveauSelecteurB = document.createElement('select');
			var nouveauBoutonSup = document.createElement('input');
			var textEntre = document.createTextNode('Entre ');
			var textet = document.createTextNode(' et ');

			// Definition du numero de la nouvelle zone
			var flux = 'flux' + (++document.getElementById('dernierId').value);

			// Nouveaux selecteurs de zone ou GZone
			nouveauSelecteurA.name = flux + '_A';
			nouveauSelecteurB.name = flux + '_B';

			var listeDesZones = document.getElementById('listeDesZones');

			// Options du premier selecteur de zone/GZone (genere a partir du selecteur d'exemple)
			for(var i = 0; i < listeDesZones.childNodes.length; i++) {
				var option = listeDesZones.childNodes[i];

				// Pour chaque option du selecteur d'exemple
				if(/OPTION/i.test(option.nodeName) && option.value) {
					var newOption = document.createElement('option');
					newOption.value = option.value;
					newOption.text = option.text;

					if(option.value == selectZoneA.value)
						newOption.selected = 'selected';

					if(option.className == 'separation') {
						newOption.className = 'separation';
						newOption.disabled = true;
					}

					nouveauSelecteurA.appendChild(newOption);
				}
			}

			// Options du second selecteur de zone/GZone (genere a partir du selecteur d'exemple)
			for(var i = 0; i < listeDesZones.childNodes.length; i++) {
				var option = listeDesZones.childNodes[i];

				// Pour chaque option du selecteur d'exemple
				if(/OPTION/i.test(option.nodeName) && option.value) {
					var newOption = document.createElement('option');
					newOption.value = option.value;
					newOption.text = option.text;

					if(option.value == selectZoneB.value)
						newOption.selected = 'selected';

					if(option.className == 'separation') {
						newOption.className = 'separation';
						newOption.disabled = true;
					}

					nouveauSelecteurB.appendChild(newOption);
				}
			}

			// Nouveau bouton de suppression associe
			nouveauBoutonSup.type = 'button';
			nouveauBoutonSup.value = 'X';
			nouveauBoutonSup.title = 'Supprimer';
			nouveauBoutonSup.onclick = Zones.supprimer;
			nouveauBoutonSup.className = 'boutonSup';

			// Imbrication des elements
			nouvelleLigne.appendChild(textEntre);
			nouvelleLigne.appendChild(nouveauSelecteurA);
			nouvelleLigne.appendChild(textet);
			nouvelleLigne.appendChild(nouveauSelecteurB);
			nouvelleLigne.appendChild(nouveauBoutonSup);
	
			// Ajout du tout sur la page
			liste.insertBefore(nouvelleLigne, this.parentNode);

			// Reinitialisation des selects
			selectZoneA.selectedIndex = 0;
			selectZoneB.selectedIndex = 0;
		}
	}
}
