/*
 * Copyright (C) 2010 Julien VAUBOURG
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

GZones = {

	// Ajoute une zone dans la liste d'une GZone, par l'intermediaire de la derniere ligne de cette GZone
	// REM: Dans le contexte d'un bouton d'ajout de zone
	ajouterZone: function() {

		// Recuperation du select permettant de choisir la zone a ajouter
		var selectZone = this.previousSibling;

		// Si une zone a bien ete selectionnee
		if(selectZone[selectZone.selectedIndex].text != '-') {
			var liste = this.parentNode.parentNode;
			var gzone = liste.id;

			// Verification de l'unicite de la zone : avorte la fonction en cas de reussite de la fonction !
			if(Zones.ceNomExiste(selectZone.value, liste)) {
				alert('Cette zone a d\351j\340 \351t\351 ajout\351 \340 cette liste.');
				return false;
			}

			// Creation des elements a ajouter
			var nouvelleLigne = document.createElement('li');
			var nouveauSelecteur = document.createElement('select');
			var nouveauBoutonSup = document.createElement('input');

			// Nouveau selecteur de zone
			nouveauSelecteur.name = gzone + '_zone';

			var listeDesZones = document.getElementById('listeDesZones');

			// Options du selecteur de zone (genere a partir du selecteur d'exemple)
			for(var i = 0; i < listeDesZones.childNodes.length; i++) {
				var option = listeDesZones.childNodes[i];

				// Pour chaque option du selecteur d'exemple
				if(/OPTION/i.test(option.nodeName) && option.value) {
					var newOption = document.createElement('option');
					newOption.value = option.value;
					newOption.text = option.text;

					if(option.value == selectZone.value)
						newOption.selected = 'selected';

					nouveauSelecteur.appendChild(newOption);
				}
			}

			// Nouveau bouton de suppression associe
			nouveauBoutonSup.type = 'button';
			nouveauBoutonSup.value = 'X';
			nouveauBoutonSup.title = 'Supprimer';
			nouveauBoutonSup.onclick = Zones.supprimer;
			nouveauBoutonSup.className = 'boutonSup';

			// Imbrication des elements
			nouvelleLigne.appendChild(nouveauSelecteur);
			nouvelleLigne.appendChild(nouveauBoutonSup);
	
			// Ajout du tout sur la page
			liste.insertBefore(nouvelleLigne, this.parentNode);

			// Reinitialisation du champ d'ajout d'adresse
			selectZone.selectedIndex = 0;
		}
	},

	// Ajoute une GZone dans la liste des GZones, par l'intermediaire du champ d'ajout situe a la fin de cette liste
	// REM: Dans le contexte d'un bouton d'ajout de GZone
	ajouterGZone: function() {

		// Recuperation du selecteur permettant de rajouter une zone
		var champZone = this.previousSibling;

		if(champZone.value != 'Nouveau groupe') {
			var liste = this.parentNode.parentNode;

			// Verification de l'unicite de la zone : avorte la fonction en cas de reussite de la fonction !
			if(Zones.ceNomExiste(champZone.value, liste)) {
				alert('Impossible de cr\351er le groupe :\nce nom a d\351j\340 \351t\351 attribu\351.');
				return false;
			}

			var nouvelleLigne = document.createElement('li');
			var nouveauChamp = document.createElement('input');

			// Creation des elements a ajouter
			var nouvelleListeZones = document.createElement('ul');
			var nouvelleLigneZone = document.createElement('li');
			var nouveauBoutonSup = document.createElement('input');
			var nouveauSelectAjout = document.createElement('select');
			var nouveauBoutonAjout = document.createElement('input');

			var listeZonesPrecedente = Noeuds.noeudPrecedent.apply(this.parentNode);

			// Definition du numero de la nouvelle zone
			nouvelleListeZones.id = ++document.getElementById('dernierId').value;

			// Nouveau champ contenant le nom de la zone
			nouveauChamp.type = 'text';
			nouveauChamp.name = nouvelleListeZones.id;
			nouveauChamp.value = champZone.value;
			nouveauChamp.className = 'champNomZone';

			// Nouveau bouton de suppression pour la nouvelle zone
			nouveauBoutonSup.type = 'button';
			nouveauBoutonSup.value = 'X';
			nouveauBoutonSup.title = 'Supprimer cette GZone';
			nouveauBoutonSup.onclick = Zones.supprimer;
			nouveauBoutonSup.className = 'boutonSup'

			// Options du selecteur de zone (genere a partir du selecteur d'exemple)
			var listeDesZones = document.getElementById('listeDesZones');

			for(var i = 0; i < listeDesZones.childNodes.length; i++) {
				var option = listeDesZones.childNodes[i];

				if(/OPTION/i.test(option.nodeName) && option.value) {
					var newOption = document.createElement('option');
					newOption.value = option.value;
					newOption.text = option.text;
					nouveauSelectAjout.appendChild(newOption);
				}
			}

			// Nouveau champ d'ajout d'ajout d'adresse pour la nouvelle zone
			nouveauSelectAjout.className = 'champAjout';

			// Nouveau bouton d'ajout pour la nouvelle zone
			nouveauBoutonAjout.type = 'button';
			nouveauBoutonAjout.onclick = GZones.ajouterZone;
			nouveauBoutonAjout.value = 'Ajouter';
			nouveauBoutonAjout.className = 'boutonAjout';

			// Imbrication des elements
			nouvelleLigne.appendChild(nouveauChamp);
			nouvelleLigne.appendChild(nouveauBoutonSup);
			nouvelleLigneZone.appendChild(nouveauSelectAjout);
			nouvelleLigneZone.appendChild(nouveauBoutonAjout);
			nouvelleListeZones.appendChild(nouvelleLigneZone);
			nouvelleLigne.appendChild(nouvelleListeZones);
	
			// Ajout du tout sur la page
			liste.insertBefore(nouvelleLigne, this.parentNode);

			champZone.value = '';
			champZone.onblur();
		}
	}
}
