/*
 * Copyright (C) 2010 Julien VAUBOURG
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

Matrice = {

	// Ajoute une zone ou une GZone a la composition de la matrice
	// REM: Dans le contexte d'un bouton d'ajout de zone/GZone
	ajouterZoneGZone: function() {

		// Recuperation du select qui permet d'ajouter une zone/GZone
		var selectZoneGZone = Noeuds.noeudPrecedent.apply(this);

		// Si ces la zone/GZone a bien ete definie
		if(selectZoneGZone[selectZoneGZone.selectedIndex].text != '-') {
			var liste = this.parentNode.parentNode;

			// Verification de l'unicite de la zone/GZone dans la matrice : avorte la fonction en cas de reussite de la fonction !
			if(Zones.ceNomExiste(selectZoneGZone.value, liste)) {
				alert('Cette (G)Zone a d\351j\340 \351t\351 ajout\351 \340 la matrice.');
				return false;
			}

			// Creation des elements a ajouter
			var nouvelleLigne = document.createElement('li');
			var nouveauSelecteurZoneGZone = document.createElement('select');
			var nouveauBoutonSup = document.createElement('input');

			// Definition du numero de la nouvelle entree
			var matrice = 'matrice' + (++document.getElementById('dernierId').value);

			// Nouveaux selecteurs de zone ou GZone
			nouveauSelecteurZoneGZone.name = matrice;

			var listeDesZones = document.getElementById('listeDesZones');

			// Options du premier selecteur de zone/GZone (genere a partir du selecteur d'exemple)
			for(var i = 0; i < listeDesZones.childNodes.length; i++) {
				var option = listeDesZones.childNodes[i];

				// Pour chaque option du selecteur d'exemple
				if(/OPTION/i.test(option.nodeName) && option.value) {
					var newOption = document.createElement('option');
					newOption.value = option.value;
					newOption.text = option.text;

					if(option.value == selectZoneGZone.value)
						newOption.selected = 'selected';

					if(option.className == 'separation') {
						newOption.className = 'separation';
						newOption.disabled = true;
					}

					nouveauSelecteurZoneGZone.appendChild(newOption);
				}
			}

			// Nouveau bouton de suppression associe
			nouveauBoutonSup.type = 'button';
			nouveauBoutonSup.value = 'X';
			nouveauBoutonSup.title = 'Supprimer';
			nouveauBoutonSup.onclick = Zones.supprimer;
			nouveauBoutonSup.className = 'boutonSup';

			// Imbrication des elements
			nouvelleLigne.appendChild(nouveauSelecteurZoneGZone);
			nouvelleLigne.appendChild(nouveauBoutonSup);
	
			// Ajout du tout sur la page
			liste.insertBefore(nouvelleLigne, this.parentNode);

			// Reinitialisation des selects
			selectZoneGZone.selectedIndex = 0;
		}
	}
}
