/*
 * Copyright (C) 2010 Julien VAUBOURG
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

Noeuds = {

	// Trouve l'element precedant celui du contexte, qui n'est pas un noeud texte (les # de mozilla)
	// REM: Dans le contexte d'un noeud
	// @return : Le noeud precedent
	noeudPrecedent: function() {
		var noeud = this;

		do {
			noeud = noeud.previousSibling;
		} while(noeud != null && /^#/.test(noeud.nodeName));

		return noeud;
	},

	// Trouve l'element suivant celui du contexte, qui n'est pas un noeud texte (les # de mozilla)
	// REM: Dans le contexte d'un noeud
	// @return : Le prochain noeud
	prochainNoeud: function() {
		var noeud = this;

		do {
			noeud = noeud.nextSibling;
		} while(noeud != null && /^#/.test(noeud.nodeName));

		return noeud;
	},

	// Trouve le premier noeud non-texte d'un element
	// REM: Dans le contexte de l'element
	// @return : Premie rnoeud
	premierNoeud: function() {
		return /^#/.test(this.firstChild.nodeName) ? Noeuds.prochainNoeud.apply(this.firstChild) : this.firstChild;
	},

	// Trouve le premier noeud non-texte d'un element
	// REM: Dans le contexte de l'element
	// @return : Premier noeud
	dernierNoeud: function() {
		return /^#/.test(this.lastChild.nodeName) ? Noeuds.noeudPrecedent.apply(this.lastChild) : this.lastChild;
	}
}
