%% Rapport d'audit pour <QUI> sur la période du <DEBUT> au <FIN>
%% @author : <julien.vaubourg.com> pour CSONE

\pdfcompresslevel0 % Compression du PDF (0-9, par defaut a 0)
\documentclass[a4paper,oneside]{report} % Format A4 sans recto-verso

\usepackage[frenchb]{babel} % Entre autres pour les accents
\usepackage[T1]{fontenc} % Mise en service de régles de typographie françaises
%\usepackage[utf8]{inputenc} % En UTF-8
\usepackage{geometry} % Pour les marges
\geometry{dvips,a4paper,margin=1.5cm} % Redéfinition des marges
\geometry{ hmargin=1cm } % Marge pour la reliure et les bandeaux en bas
\setlength\textwidth{19cm} % Redéfinition de la largeur de la page
\setlength\textheight{25.5cm} % Redéfinition de la hauteur de la page
\setcounter{tocdepth}{1} % Profondeur de la table des matieres

\usepackage{color} % Pour les couleurs
\usepackage[table]{xcolor} % Pour colorer les tableaux
\usepackage{rotating} % Rotation à 90° avec sideways
\usepackage{multirow} % Pour pouvoir fusionner des cellules verticalement
\renewcommand{\multirowsetup}{\raggedleft} % Alignement à droite des multirow
\usepackage{colortbl,hhline} % Sans ça, pas de bordure au dessus des cases de tableaux colorées (hhline remplace cline)

\usepackage{eso-pic} % Pour les images de fond
\usepackage{graphicx} % Idem et pour les images en général
\AddToShipoutPicture*{\put(0, 733){\includegraphics{images/csone.png}}} % Image du haut
\AddToShipoutPicture*{\put(0, 0){\includegraphics{images/mentions.png}}} % Image du bas (premiere page)
\AddToShipoutPicture{\put(0, 0){\includegraphics{images/pied.png}}} % Image du bas (chaque page)

\usepackage{fancyhdr} % Pour les entêtes et pieds de page
\pagestyle{fancy} % Application du style fancy pour profiter de ses commandes
\chead{} % Milieu des entêtes
\rhead{CS One - <QUI>} % Entêtes côté droit
\usepackage{lastpage} % Pour avoir le nombre de page total (nécessite deux compilations)
\rfoot{\vspace{0pt}\textbf{\color{white}{\thepage\ / \pageref{LastPage}}}} % Pieds de page
\cfoot{} % Pas de numérotation auto des pages

\renewcommand\thesection{\vspace{1cm} \arabic{section}} % Les sections se numérotent en chiffres romaines
\renewcommand\thesubsection{\vspace{1cm} \thesection .\Alph{subsection}} % Les sous-sections en lettres majuscules
\renewcommand\headrulewidth{0mm} % Pas de lignes en dessous des entêtes
\renewcommand\footrulewidth{0mm} % Idem pour les pieds de page
\renewcommand\rmdefault{phv} % Police par défaut Helvetica

\definecolor{vert}{RGB}{151, 185, 30} % Un beau vert foncé CS One
\definecolor{vertClair}{RGB}{251, 250, 218} % Le même en beaucoup plus clair
\definecolor{tab0}{gray}{0.9} % Couleur des lignes paires des tableaux
\definecolor{tab1}{gray}{1} % Idem pour les impaires
\definecolor{tabLabel}{RGB}{151, 185, 30} % Couleur de fond des labels dans les tableaux

% Couleurs des niveaux de categories (en hexa dans arti.ph)
% 810100 ff0100 ff6300 ffcf00
\definecolor{catNiveau1}{RGB}{129, 1, 0}
\definecolor{catNiveau2}{RGB}{255, 1, 0}
\definecolor{catNiveau3}{RGB}{255, 99, 0}
\definecolor{catNiveau4}{RGB}{255, 207, 0}

\renewcommand\label[1]{\color{white}{\textbf{#1}}} % Style des labels des tableaux
\newcommand\labelIP[1]{\color{white}{#1}} % Style des labels des tableaux quand ce sont des IP
\newcommand\legende[1]{\large{#1}} % Style des legendes de graphs ou tableaux
\newcommand\indication[1]{\textbf{\color{vert}{#1}}} % Style des indications autour des tableaux

\title { % Titre du document, appellé dans \maketitle
	\vspace{3cm}
	\begin{tabular}{p{4cm} r}
		& \Huge{\textbf{Rapport d'audit}}\\
		& \\
		& \huge{<QUI>}\\
		& \\
		& \\
		& \LARGE{Analyse du <DEBUT> au <FIN>}
	\end{tabular}\\
	\vspace{2mm}
	\color{vert}{\rule{16cm}{1mm}}
	\vspace{2mm}\\
	\begin{tabular}{p{10cm} r}
		& \large{Rapport édité le \today}
	\end{tabular}\\
	\vspace{9cm}
}

\author{ % Auteur, appellé aussi dans \maketitle
	\begin{tabular}{p{10cm}}
		\begin{center}
			\textbf{CS One} - 42 avenue Montaigne 75008 Paris\\
			\textit{Cabinet de consultants en architectures réseaux, sécurité et téléphonie IP}
		\end{center}
	\end{tabular}
}

\date{}

% Document
\begin{document}

\maketitle % Construction de la première page de titre
\tableofcontents % Seconde page : table des matières (nécessite deux compilations)
\newpage

% Introduction
~
\section{Introduction}
<INTRO>
\newpage


% Let's go!
