#!/usr/bin/perl

# Copyright (C) 2010 Julien VAUBOURG
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

use lib '/home/sonde/classes';

use strict;
use PSM::Zones;

Zones::lire();

my $zoneDeDst;
my $zoneSrc;  
my %tableauPorts = ();

open(FICHIER, "../dumps/tri.parSubnet") or die "ERREUR: Impossible d'ouvrir tri.parSubnet";
while (<FICHIER>) {                                                                        
  # Extraction des donnees contenues dans le fichier tri.parSubnet                         
        my ($IPsrc, $port, $IPdst) = split (/ /,$_);                                       
        my $zoneDeIPsrc = @{Zones::quellesZones($IPsrc)}[0];                               
        my $zoneDeIPdst = @{Zones::quellesZones($IPdst)}[0];                               

	if ($port > 65536) {
	  #il y a quelque chose qui ne va pas, le port TCP étant codé sur 2 octets
	  print "\n";
	  print "Warning : port TCP > 65536 : Accès de $IPsrc vers $IPdst sur le port $port\n";
	} else {
	  #Le port est compris entre 0 et 65536, donc tout va bien

	  print "check $zoneDeIPsrc, $port, $zoneDeIPdst\n";

	  if ($tableauPorts{$zoneDeIPsrc}) {
                #L'entree existe, pour cette zone, on recherche le tableau contenant le port
                my $size = @{$tableauPorts{$zoneDeIPsrc}};                                  
                my $nonTrouve = 1;                                                          
                my $i = 0;                                                                  
                while ($nonTrouve && $i<$size) {                                            
                        if ( @{@{$tableauPorts{$zoneDeIPsrc}}[$i]}[0] == $port ) {          
                                $nonTrouve=0;
                        }
                        else {
                                $i++;
                        }
                }

                if ($nonTrouve) {
                        #La zone source existe mais pas le numero de port
                        my @tableau = ([$port, [$zoneDeIPdst]]);
                        push ( @{$tableauPorts{$zoneDeIPsrc}} , @tableau);
                }
                else {
                        #la zone source existe et le numero de port aussi
                        #On regarde si la destination n'est pas deja connue
                        if ( !grep(($_ == $zoneDeIPdst), @{@{@{$tableauPorts{$zoneDeIPsrc}}[$i]}[1]} ) ){
                                push ( @{@{@{$tableauPorts{$zoneDeIPsrc}}[$i]}[1]} , $zoneDeIPdst);
                        }
                }
	  } else {
	    @{$tableauPorts{$zoneDeIPsrc}} = ([$port, [$zoneDeIPdst]]);
            print "Ajout de $zoneDeIPsrc, $port, $zoneDeIPdst\n";
	  }

	}
}

print "===== RESULTAT =====";
while ( my ($cleHash, $valeurHash) = each(%tableauPorts) ) {
        my $nomZoneSrc = Zones::label($cleHash);
        print "\\textebf{$nomZoneSrc}\\\\n";

	#Tout d'abord on tri les donnees pour afficher les numéros de ports dans le sens croissant.
	my @tableauDesPortsTries = sort { $a->[0] <=> $b->[0] } @{$valeurHash};
	
	#Pour chaque no de port
        foreach (@tableauDesPortsTries) {
		#On affiche le no port
                print "@{$_}[0] ";

		my $PremiereZonedeDestination = 1; #est utilise pour separer par une virgule les zones de destination
		#Pour chaque destination
                foreach (@{@{$_}[1]}) {
                        if ( $_ == 'internet') {
				#Si la destination c'est Internet, on affiche 'internet'    
                                if ($PremiereZonedeDestination){
				    print "$_";
				} else {
				    print", $_";	
				}
                        } else {
				#Sinon on recherche le nom correspondant au numéro de zone et on l'affiche
                                my $nomZoneDst = Zones::label($_);
				  if ($PremiereZonedeDestination){
				    print "$nomZoneDst";
				  } else {
				    print ", $nomZoneDst";
				  }
                        }
			$PremiereZonedeDestination = 0; #Ce n'est plus la premiere zone, pour les suivantes, on met un virgule
                }

                print "\\\\n";
		print "\n";
        }
      
}




