#!/usr/bin/perl

# Copyright (C) 2010 Julien VAUBOURG
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

use lib '/home/sonde/classes';
use strict;

use PSM::RRD;
use PSM::Capture;


# UTILISATION
#
# ./capture.pl bin2txt : Transforme les fichiers pcap de dumps/ en fichiers textes ne contenant que les entetes des paquets qui nous
# interessent. Il sont crees dans dumps/text/.
# ./capture.pl rrd : Transforme les fichiers d'entetes de paquets de dumps/text/ en une arborescence de fichiers RRD dans le dossier rrd/
# ./capture.pl all : Execute les actions de bin2txt et rrd (cree les fichiers d'entetes puis l'arborescence RRD)


# Periode d'observation des RRD
RRD::setPeriode('1243341550', '1244040871');

# Instance de transformation des dumps en bases RRD
my $cap = new Capture();

# Creations des fichiers textes contenant les entetes des paquets (si le script est appelle avec l'option bin2txt ou all)
$cap->bin2txt() if @ARGV[0] =~ /(bin2txt|all)/;

# Creation de toute l'arborescence des RRD et injection des donnees lues dans les paquets (si le script est appelle avec l'option rrd ou all)
$cap->lire() if @ARGV[0] =~ /(rrd|all)/;

# Generation du fichier .hash d'association IP-domaines pour la zone internet, dans config/
$cap->domaines() if @ARGV[0] =~ /(domaines|all)/;
